
#include <iostream>
#include <cmath>
#include "string.hh"
#include "glued.hh"

double
sum (mmx::glued_tuple<double> a) {
  using namespace mmx;
  double s= 0.0;
  int i, n= N(a);
  for (i=0; i<n; i++)
    s += a[i];
  return s;
}

double
sum_prod (mmx::glued_tuple<mmx::glued_tuple<double> > a) {
  using namespace mmx;
  double s= 0.0;
  int i, n= N(a);
  for (i=0; i<n; i++) {
    double p= 1.0;
    int j, r= N(a[i]);
    for (j=0; j<r; j++)
      p *= a[i][j];
    s += p;
  }
  return s;
}


#include "config.hh"
#include "generic.hh"
#include "list.hh"
#include "string.hh"
#include "gentable.hh"
#include "table.hh"
#include "symbol.hh"
#include "single.hh"
#include "printer.hh"
#include "literal.hh"
#include "alias.hh"
#include "mirror.hh"
#include "value.hh"
#include "symbols.hh"
#include "glued.hh"

static mmx::generic ID_1 = mmx::mirror (mmx::symbol ("Double"));

static mmx::generic
FUN_2 (mmx::generic g) {
  return mmx::glued<double> (as_double (mmx::as_literal_contents (g[1])));
}

static mmx::generic
FUN_3 (mmx::generic g) {
  return mmx::printer (mmx::as_ostream (g[1]) << mmx::view_as<double> (g[2]));
}

static mmx::generic
FUN_4 (mmx::generic g) {
  return mmx::glued<double> (-mmx::view_as<double> (g[1]));
}

static mmx::generic
FUN_5 (mmx::generic g) {
  return mmx::glued<double> (mmx::view_as<double> (g[1]) + mmx::view_as<double> (g[2]));
}

static mmx::generic
FUN_6 (mmx::generic g) {
  return mmx::glued<double> (mmx::view_as<double> (g[1]) - mmx::view_as<double> (g[2]));
}

static mmx::generic
FUN_7 (mmx::generic g) {
  return mmx::glued<double> (mmx::view_as<double> (g[1]) * mmx::view_as<double> (g[2]));
}

static mmx::generic
FUN_8 (mmx::generic g) {
  return mmx::glued<double> (mmx::view_as<double> (g[1]) / mmx::view_as<double> (g[2]));
}

static mmx::generic
FUN_9 (mmx::generic g) {
  return mmx::glued<double> (pow (mmx::view_as<double> (g[1]), mmx::as_int (g[2])));
}

static mmx::generic
FUN_10 (mmx::generic g) {
  return mmx::glued<double> (pow (mmx::view_as<double> (g[1]), mmx::view_as<double> (g[2])));
}

static mmx::generic
FUN_11 (mmx::generic g) {
  return mmx::glued_alias<double> (mmx::view_as_alias<double> (g[1]) += mmx::view_as<double> (g[2]));
}

static mmx::generic
FUN_12 (mmx::generic g) {
  return mmx::glued_alias<double> (mmx::view_as_alias<double> (g[1]) -= mmx::view_as<double> (g[2]));
}

static mmx::generic
FUN_13 (mmx::generic g) {
  return mmx::glued_alias<double> (mmx::view_as_alias<double> (g[1]) *= mmx::view_as<double> (g[2]));
}

static mmx::generic
FUN_14 (mmx::generic g) {
  return mmx::glued_alias<double> (mmx::view_as_alias<double> (g[1]) /= mmx::view_as<double> (g[2]));
}

static mmx::generic
FUN_15 (mmx::generic g) {
  return mmx::single (mmx::view_as<double> (g[1]) == mmx::view_as<double> (g[2]));
}

static mmx::generic
FUN_16 (mmx::generic g) {
  return mmx::single (mmx::view_as<double> (g[1]) != mmx::view_as<double> (g[2]));
}

static mmx::generic
FUN_17 (mmx::generic g) {
  return mmx::single (mmx::view_as<double> (g[1]) < mmx::view_as<double> (g[2]));
}

static mmx::generic
FUN_18 (mmx::generic g) {
  return mmx::single (mmx::view_as<double> (g[1]) <= mmx::view_as<double> (g[2]));
}

static mmx::generic
FUN_19 (mmx::generic g) {
  return mmx::single (mmx::view_as<double> (g[1]) > mmx::view_as<double> (g[2]));
}

static mmx::generic
FUN_20 (mmx::generic g) {
  return mmx::single (mmx::view_as<double> (g[1]) >= mmx::view_as<double> (g[2]));
}

static mmx::generic
FUN_21 (mmx::generic g) {
  return mmx::glued<double> (fabs (mmx::view_as<double> (g[1])));
}

static mmx::generic
FUN_22 (mmx::generic g) {
  return mmx::glued<double> (sqrt (mmx::view_as<double> (g[1])));
}

static mmx::generic
FUN_23 (mmx::generic g) {
  return mmx::glued<double> (exp (mmx::view_as<double> (g[1])));
}

static mmx::generic
FUN_24 (mmx::generic g) {
  return mmx::glued<double> (log (mmx::view_as<double> (g[1])));
}

static mmx::generic
FUN_25 (mmx::generic g) {
  return mmx::glued<double> (sin (mmx::view_as<double> (g[1])));
}

static mmx::generic
FUN_26 (mmx::generic g) {
  return mmx::glued<double> (cos (mmx::view_as<double> (g[1])));
}

static mmx::generic
FUN_27 (mmx::generic g) {
  return mmx::glued<double> (tan (mmx::view_as<double> (g[1])));
}

static mmx::generic
FUN_28 (mmx::generic g) {
  return mmx::glued<double> (sinh (mmx::view_as<double> (g[1])));
}

static mmx::generic
FUN_29 (mmx::generic g) {
  return mmx::glued<double> (cosh (mmx::view_as<double> (g[1])));
}

static mmx::generic
FUN_30 (mmx::generic g) {
  return mmx::glued<double> (tanh (mmx::view_as<double> (g[1])));
}

static mmx::generic
FUN_31 (mmx::generic g) {
  return mmx::glued<double> (asin (mmx::view_as<double> (g[1])));
}

static mmx::generic
FUN_32 (mmx::generic g) {
  return mmx::glued<double> (acos (mmx::view_as<double> (g[1])));
}

static mmx::generic
FUN_33 (mmx::generic g) {
  return mmx::glued<double> (atan (mmx::view_as<double> (g[1])));
}

static mmx::generic
FUN_34 (mmx::generic g) {
  return mmx::glued<double> (atan2 (mmx::view_as<double> (g[1]), mmx::view_as<double> (g[2])));
}

static mmx::generic
FUN_35 (mmx::generic g) {
  return mmx::glued<double> (floor (mmx::view_as<double> (g[1])));
}

static mmx::generic
FUN_36 (mmx::generic g) {
  return mmx::glued<double> (ceil (mmx::view_as<double> (g[1])));
}

static mmx::generic
FUN_37 (mmx::generic g) {
  return mmx::glued<double> (sum (mmx::glued_tuple<double> (g)));
}

static mmx::generic
FUN_38 (mmx::generic g) {
  return mmx::glued<double> (sum_prod (mmx::glued_tuple<mmx::glued_tuple<double> > (g[1])));
}

extern "C" void
init_simple () {
  mmx::extern_declare ("Double", ID_1, mmx::ID_CLASS);
  mmx::extern_declare ("literal_float!", FUN_2, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::ID_LITERAL_FLOAT), ID_1));
  mmx::extern_declare ("<<%", FUN_3, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::ID_OSTREAM, ID_1), mmx::ID_OSTREAM));
  mmx::extern_declare ("-", FUN_4, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, ID_1), ID_1));
  mmx::extern_declare ("+", FUN_5, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, ID_1, ID_1), ID_1));
  mmx::extern_declare ("-", FUN_6, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, ID_1, ID_1), ID_1));
  mmx::extern_declare ("*", FUN_7, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, ID_1, ID_1), ID_1));
  mmx::extern_declare ("/", FUN_8, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, ID_1, ID_1), ID_1));
  mmx::extern_declare ("^", FUN_9, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, ID_1, mmx::ID_INT), ID_1));
  mmx::extern_declare ("^", FUN_10, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, ID_1, ID_1), ID_1));
  mmx::extern_declare ("+=", FUN_11, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (mmx::ID_ALIAS, ID_1), ID_1), mmx::list (mmx::ID_ALIAS, ID_1)));
  mmx::extern_declare ("-=", FUN_12, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (mmx::ID_ALIAS, ID_1), ID_1), mmx::list (mmx::ID_ALIAS, ID_1)));
  mmx::extern_declare ("*=", FUN_13, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (mmx::ID_ALIAS, ID_1), ID_1), mmx::list (mmx::ID_ALIAS, ID_1)));
  mmx::extern_declare ("/=", FUN_14, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (mmx::ID_ALIAS, ID_1), ID_1), mmx::list (mmx::ID_ALIAS, ID_1)));
  mmx::extern_declare ("=", FUN_15, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, ID_1, ID_1), mmx::ID_BOOL));
  mmx::extern_declare ("!=", FUN_16, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, ID_1, ID_1), mmx::ID_BOOL));
  mmx::extern_declare ("<", FUN_17, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, ID_1, ID_1), mmx::ID_BOOL));
  mmx::extern_declare ("<=", FUN_18, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, ID_1, ID_1), mmx::ID_BOOL));
  mmx::extern_declare (">", FUN_19, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, ID_1, ID_1), mmx::ID_BOOL));
  mmx::extern_declare (">=", FUN_20, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, ID_1, ID_1), mmx::ID_BOOL));
  mmx::extern_declare ("abs", FUN_21, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, ID_1), ID_1));
  mmx::extern_declare ("sqrt", FUN_22, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, ID_1), ID_1));
  mmx::extern_declare ("exp", FUN_23, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, ID_1), ID_1));
  mmx::extern_declare ("ln", FUN_24, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, ID_1), ID_1));
  mmx::extern_declare ("sin", FUN_25, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, ID_1), ID_1));
  mmx::extern_declare ("cos", FUN_26, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, ID_1), ID_1));
  mmx::extern_declare ("tan", FUN_27, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, ID_1), ID_1));
  mmx::extern_declare ("sh", FUN_28, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, ID_1), ID_1));
  mmx::extern_declare ("ch", FUN_29, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, ID_1), ID_1));
  mmx::extern_declare ("th", FUN_30, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, ID_1), ID_1));
  mmx::extern_declare ("arcsin", FUN_31, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, ID_1), ID_1));
  mmx::extern_declare ("arccos", FUN_32, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, ID_1), ID_1));
  mmx::extern_declare ("arctan", FUN_33, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, ID_1), ID_1));
  mmx::extern_declare ("arctan", FUN_34, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, ID_1, ID_1), ID_1));
  mmx::extern_declare ("floor", FUN_35, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, ID_1), ID_1));
  mmx::extern_declare ("ceil", FUN_36, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, ID_1), ID_1));
  mmx::extern_declare ("sum", FUN_37, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_TUPLETYPE, ID_1), ID_1));
  mmx::extern_declare ("sum_prod", FUN_38, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (mmx::ID_VTUPLETYPE, mmx::list (mmx::ID_TUPLETYPE, ID_1))), ID_1));
}

