
#include <iostream>
#include <cmath>
#include <complex>
#include <vector>
#include <slist>
#include <valarray>

#include "glued.hh"
#include "list.hh"
#include "symbol.hh"
#include "mirror.hh"
#include "symbols.hh"
#include "extern.hh"

struct stl_inst {
  void *rep;
  inline stl_inst (): rep (NULL) {}
  inline stl_inst (void *rep2): rep (rep2) {}
  inline stl_inst (const stl_inst &bb): rep (bb.rep) {}
  inline ~stl_inst () {}
};

template<class T, class F> struct converter {
  static inline T
  helper (F x) {
    return (T) x;
  }
};

template<class T> struct converter<T, stl_inst> {
  static inline T
  helper (stl_inst x) {
    return *((T*) x.rep);
  }
};

template<class F> struct converter<stl_inst, F> {
  static inline stl_inst
  helper (F x) {
    return stl_inst (new F (x));
  }
};

template<class T> struct converter<T&, stl_inst& > {
  static inline T
  &helper (stl_inst &x) {
    return *((T*) x.rep);
  }
};

template<class F> struct converter<stl_inst&, F& > {
  static inline stl_inst
  &helper (F &x) {
    return *new stl_inst (&x);
  }
};

template<class T, class F> inline T
convert (F x) {
  return converter<T, F>::helper (x);
}

template<class T, class F> struct caster {
  static inline T
  helper (F x) {
    return *reinterpret_cast<T* > (&x);
  }
};

template<class T, class F> struct caster<T&, F& > {
  static inline T
  &helper (F &x) {
    return *reinterpret_cast<T* > (&x);
  }
};

template<class T, class F> inline T
cast (F x) {
  return caster<T, F>::helper (x);
}

struct stl_type_rep;
typedef stl_type_rep *stl_type;

struct stl_type_rep {
  inline stl_type_rep () {}
  inline virtual ~stl_type_rep () {}
  virtual ostream &gen_lessless (ostream&, stl_inst);
  virtual stl_inst gen_minus (stl_inst);
  virtual stl_inst gen_plus (stl_inst, stl_inst);
  virtual stl_inst gen_minus (stl_inst, stl_inst);
  virtual stl_inst gen_times (stl_inst, stl_inst);
  virtual stl_inst gen_over (stl_inst, stl_inst);
  virtual stl_inst gen_pow (stl_inst, int);
  virtual stl_inst gen_pow (stl_inst, stl_inst);
  virtual stl_inst &gen_plusassign (stl_inst&, stl_inst);
  virtual stl_inst &gen_minusassign (stl_inst&, stl_inst);
  virtual stl_inst &gen_timesassign (stl_inst&, stl_inst);
  virtual stl_inst &gen_overassign (stl_inst&, stl_inst);
  virtual bool gen_equal (stl_inst, stl_inst);
  virtual bool gen_unequal (stl_inst, stl_inst);
  virtual bool gen_less (stl_inst, stl_inst);
  virtual bool gen_lesseq (stl_inst, stl_inst);
  virtual bool gen_gtr (stl_inst, stl_inst);
  virtual bool gen_gtreq (stl_inst, stl_inst);
  virtual stl_inst gen_abs (stl_inst);
  virtual stl_inst gen_sqrt (stl_inst);
  virtual stl_inst gen_exp (stl_inst);
  virtual stl_inst gen_log (stl_inst);
  virtual stl_inst gen_sin (stl_inst);
  virtual stl_inst gen_cos (stl_inst);
  virtual stl_inst gen_tan (stl_inst);
  virtual stl_inst gen_sinh (stl_inst);
  virtual stl_inst gen_cosh (stl_inst);
  virtual stl_inst gen_tanh (stl_inst);
  virtual stl_inst gen_asin (stl_inst);
  virtual stl_inst gen_acos (stl_inst);
  virtual stl_inst gen_atan (stl_inst);
  virtual stl_inst gen_atan2 (stl_inst, stl_inst);
  virtual stl_inst gen_hypot (stl_inst, stl_inst);
};

ostream
&stl_type_rep::gen_lessless (ostream &arg_1, stl_inst arg_2) {
  cerr << "Fatal error: unsupported method\n";
  exit (1);
}

stl_inst
stl_type_rep::gen_minus (stl_inst arg_1) {
  cerr << "Fatal error: unsupported method\n";
  exit (1);
}

stl_inst
stl_type_rep::gen_plus (stl_inst arg_1, stl_inst arg_2) {
  cerr << "Fatal error: unsupported method\n";
  exit (1);
}

stl_inst
stl_type_rep::gen_minus (stl_inst arg_1, stl_inst arg_2) {
  cerr << "Fatal error: unsupported method\n";
  exit (1);
}

stl_inst
stl_type_rep::gen_times (stl_inst arg_1, stl_inst arg_2) {
  cerr << "Fatal error: unsupported method\n";
  exit (1);
}

stl_inst
stl_type_rep::gen_over (stl_inst arg_1, stl_inst arg_2) {
  cerr << "Fatal error: unsupported method\n";
  exit (1);
}

stl_inst
stl_type_rep::gen_pow (stl_inst arg_1, int arg_2) {
  cerr << "Fatal error: unsupported method\n";
  exit (1);
}

stl_inst
stl_type_rep::gen_pow (stl_inst arg_1, stl_inst arg_2) {
  cerr << "Fatal error: unsupported method\n";
  exit (1);
}

stl_inst
&stl_type_rep::gen_plusassign (stl_inst &arg_1, stl_inst arg_2) {
  cerr << "Fatal error: unsupported method\n";
  exit (1);
}

stl_inst
&stl_type_rep::gen_minusassign (stl_inst &arg_1, stl_inst arg_2) {
  cerr << "Fatal error: unsupported method\n";
  exit (1);
}

stl_inst
&stl_type_rep::gen_timesassign (stl_inst &arg_1, stl_inst arg_2) {
  cerr << "Fatal error: unsupported method\n";
  exit (1);
}

stl_inst
&stl_type_rep::gen_overassign (stl_inst &arg_1, stl_inst arg_2) {
  cerr << "Fatal error: unsupported method\n";
  exit (1);
}

bool
stl_type_rep::gen_equal (stl_inst arg_1, stl_inst arg_2) {
  cerr << "Fatal error: unsupported method\n";
  exit (1);
}

bool
stl_type_rep::gen_unequal (stl_inst arg_1, stl_inst arg_2) {
  cerr << "Fatal error: unsupported method\n";
  exit (1);
}

bool
stl_type_rep::gen_less (stl_inst arg_1, stl_inst arg_2) {
  cerr << "Fatal error: unsupported method\n";
  exit (1);
}

bool
stl_type_rep::gen_lesseq (stl_inst arg_1, stl_inst arg_2) {
  cerr << "Fatal error: unsupported method\n";
  exit (1);
}

bool
stl_type_rep::gen_gtr (stl_inst arg_1, stl_inst arg_2) {
  cerr << "Fatal error: unsupported method\n";
  exit (1);
}

bool
stl_type_rep::gen_gtreq (stl_inst arg_1, stl_inst arg_2) {
  cerr << "Fatal error: unsupported method\n";
  exit (1);
}

stl_inst
stl_type_rep::gen_abs (stl_inst arg_1) {
  cerr << "Fatal error: unsupported method\n";
  exit (1);
}

stl_inst
stl_type_rep::gen_sqrt (stl_inst arg_1) {
  cerr << "Fatal error: unsupported method\n";
  exit (1);
}

stl_inst
stl_type_rep::gen_exp (stl_inst arg_1) {
  cerr << "Fatal error: unsupported method\n";
  exit (1);
}

stl_inst
stl_type_rep::gen_log (stl_inst arg_1) {
  cerr << "Fatal error: unsupported method\n";
  exit (1);
}

stl_inst
stl_type_rep::gen_sin (stl_inst arg_1) {
  cerr << "Fatal error: unsupported method\n";
  exit (1);
}

stl_inst
stl_type_rep::gen_cos (stl_inst arg_1) {
  cerr << "Fatal error: unsupported method\n";
  exit (1);
}

stl_inst
stl_type_rep::gen_tan (stl_inst arg_1) {
  cerr << "Fatal error: unsupported method\n";
  exit (1);
}

stl_inst
stl_type_rep::gen_sinh (stl_inst arg_1) {
  cerr << "Fatal error: unsupported method\n";
  exit (1);
}

stl_inst
stl_type_rep::gen_cosh (stl_inst arg_1) {
  cerr << "Fatal error: unsupported method\n";
  exit (1);
}

stl_inst
stl_type_rep::gen_tanh (stl_inst arg_1) {
  cerr << "Fatal error: unsupported method\n";
  exit (1);
}

stl_inst
stl_type_rep::gen_asin (stl_inst arg_1) {
  cerr << "Fatal error: unsupported method\n";
  exit (1);
}

stl_inst
stl_type_rep::gen_acos (stl_inst arg_1) {
  cerr << "Fatal error: unsupported method\n";
  exit (1);
}

stl_inst
stl_type_rep::gen_atan (stl_inst arg_1) {
  cerr << "Fatal error: unsupported method\n";
  exit (1);
}

stl_inst
stl_type_rep::gen_atan2 (stl_inst arg_1, stl_inst arg_2) {
  cerr << "Fatal error: unsupported method\n";
  exit (1);
}

stl_inst
stl_type_rep::gen_hypot (stl_inst arg_1, stl_inst arg_2) {
  cerr << "Fatal error: unsupported method\n";
  exit (1);
}

static stl_type stl_cur_1;

struct stl_inst_1 {
  void *rep;
  inline stl_inst_1 (): rep (NULL) {}
  inline stl_inst_1 (void *rep2): rep (rep2) {}
  inline stl_inst_1 (const stl_inst_1 &bb): rep (bb.rep) {}
  inline ~stl_inst_1 () {}
};

ostream
&operator << (ostream &arg_1, stl_inst_1 arg_2) {
  return stl_cur_1->gen_lessless (arg_1, cast<stl_inst, stl_inst_1> (arg_2));
}

stl_inst_1
operator - (stl_inst_1 arg_1) {
  return cast<stl_inst_1, stl_inst> (stl_cur_1->gen_minus (cast<stl_inst, stl_inst_1> (arg_1)));
}

stl_inst_1
operator + (stl_inst_1 arg_1, stl_inst_1 arg_2) {
  return cast<stl_inst_1, stl_inst> (stl_cur_1->gen_plus (cast<stl_inst, stl_inst_1> (arg_1), cast<stl_inst, stl_inst_1> (arg_2)));
}

stl_inst_1
operator - (stl_inst_1 arg_1, stl_inst_1 arg_2) {
  return cast<stl_inst_1, stl_inst> (stl_cur_1->gen_minus (cast<stl_inst, stl_inst_1> (arg_1), cast<stl_inst, stl_inst_1> (arg_2)));
}

stl_inst_1
operator * (stl_inst_1 arg_1, stl_inst_1 arg_2) {
  return cast<stl_inst_1, stl_inst> (stl_cur_1->gen_times (cast<stl_inst, stl_inst_1> (arg_1), cast<stl_inst, stl_inst_1> (arg_2)));
}

stl_inst_1
operator / (stl_inst_1 arg_1, stl_inst_1 arg_2) {
  return cast<stl_inst_1, stl_inst> (stl_cur_1->gen_over (cast<stl_inst, stl_inst_1> (arg_1), cast<stl_inst, stl_inst_1> (arg_2)));
}

stl_inst_1
pow (stl_inst_1 arg_1, int arg_2) {
  return cast<stl_inst_1, stl_inst> (stl_cur_1->gen_pow (cast<stl_inst, stl_inst_1> (arg_1), arg_2));
}

stl_inst_1
pow (stl_inst_1 arg_1, stl_inst_1 arg_2) {
  return cast<stl_inst_1, stl_inst> (stl_cur_1->gen_pow (cast<stl_inst, stl_inst_1> (arg_1), cast<stl_inst, stl_inst_1> (arg_2)));
}

stl_inst_1
&operator += (stl_inst_1 &arg_1, stl_inst_1 arg_2) {
  return cast<stl_inst_1&, stl_inst& > (stl_cur_1->gen_plusassign (cast<stl_inst&, stl_inst_1& > (arg_1), cast<stl_inst, stl_inst_1> (arg_2)));
}

stl_inst_1
&operator -= (stl_inst_1 &arg_1, stl_inst_1 arg_2) {
  return cast<stl_inst_1&, stl_inst& > (stl_cur_1->gen_minusassign (cast<stl_inst&, stl_inst_1& > (arg_1), cast<stl_inst, stl_inst_1> (arg_2)));
}

stl_inst_1
&operator *= (stl_inst_1 &arg_1, stl_inst_1 arg_2) {
  return cast<stl_inst_1&, stl_inst& > (stl_cur_1->gen_timesassign (cast<stl_inst&, stl_inst_1& > (arg_1), cast<stl_inst, stl_inst_1> (arg_2)));
}

stl_inst_1
&operator /= (stl_inst_1 &arg_1, stl_inst_1 arg_2) {
  return cast<stl_inst_1&, stl_inst& > (stl_cur_1->gen_overassign (cast<stl_inst&, stl_inst_1& > (arg_1), cast<stl_inst, stl_inst_1> (arg_2)));
}

bool
operator == (stl_inst_1 arg_1, stl_inst_1 arg_2) {
  return stl_cur_1->gen_equal (cast<stl_inst, stl_inst_1> (arg_1), cast<stl_inst, stl_inst_1> (arg_2));
}

bool
operator != (stl_inst_1 arg_1, stl_inst_1 arg_2) {
  return stl_cur_1->gen_unequal (cast<stl_inst, stl_inst_1> (arg_1), cast<stl_inst, stl_inst_1> (arg_2));
}

bool
operator < (stl_inst_1 arg_1, stl_inst_1 arg_2) {
  return stl_cur_1->gen_less (cast<stl_inst, stl_inst_1> (arg_1), cast<stl_inst, stl_inst_1> (arg_2));
}

bool
operator <= (stl_inst_1 arg_1, stl_inst_1 arg_2) {
  return stl_cur_1->gen_lesseq (cast<stl_inst, stl_inst_1> (arg_1), cast<stl_inst, stl_inst_1> (arg_2));
}

bool
operator > (stl_inst_1 arg_1, stl_inst_1 arg_2) {
  return stl_cur_1->gen_gtr (cast<stl_inst, stl_inst_1> (arg_1), cast<stl_inst, stl_inst_1> (arg_2));
}

bool
operator >= (stl_inst_1 arg_1, stl_inst_1 arg_2) {
  return stl_cur_1->gen_gtreq (cast<stl_inst, stl_inst_1> (arg_1), cast<stl_inst, stl_inst_1> (arg_2));
}

stl_inst_1
abs (stl_inst_1 arg_1) {
  return cast<stl_inst_1, stl_inst> (stl_cur_1->gen_abs (cast<stl_inst, stl_inst_1> (arg_1)));
}

stl_inst_1
sqrt (stl_inst_1 arg_1) {
  return cast<stl_inst_1, stl_inst> (stl_cur_1->gen_sqrt (cast<stl_inst, stl_inst_1> (arg_1)));
}

stl_inst_1
exp (stl_inst_1 arg_1) {
  return cast<stl_inst_1, stl_inst> (stl_cur_1->gen_exp (cast<stl_inst, stl_inst_1> (arg_1)));
}

stl_inst_1
log (stl_inst_1 arg_1) {
  return cast<stl_inst_1, stl_inst> (stl_cur_1->gen_log (cast<stl_inst, stl_inst_1> (arg_1)));
}

stl_inst_1
sin (stl_inst_1 arg_1) {
  return cast<stl_inst_1, stl_inst> (stl_cur_1->gen_sin (cast<stl_inst, stl_inst_1> (arg_1)));
}

stl_inst_1
cos (stl_inst_1 arg_1) {
  return cast<stl_inst_1, stl_inst> (stl_cur_1->gen_cos (cast<stl_inst, stl_inst_1> (arg_1)));
}

stl_inst_1
tan (stl_inst_1 arg_1) {
  return cast<stl_inst_1, stl_inst> (stl_cur_1->gen_tan (cast<stl_inst, stl_inst_1> (arg_1)));
}

stl_inst_1
sinh (stl_inst_1 arg_1) {
  return cast<stl_inst_1, stl_inst> (stl_cur_1->gen_sinh (cast<stl_inst, stl_inst_1> (arg_1)));
}

stl_inst_1
cosh (stl_inst_1 arg_1) {
  return cast<stl_inst_1, stl_inst> (stl_cur_1->gen_cosh (cast<stl_inst, stl_inst_1> (arg_1)));
}

stl_inst_1
tanh (stl_inst_1 arg_1) {
  return cast<stl_inst_1, stl_inst> (stl_cur_1->gen_tanh (cast<stl_inst, stl_inst_1> (arg_1)));
}

stl_inst_1
asin (stl_inst_1 arg_1) {
  return cast<stl_inst_1, stl_inst> (stl_cur_1->gen_asin (cast<stl_inst, stl_inst_1> (arg_1)));
}

stl_inst_1
acos (stl_inst_1 arg_1) {
  return cast<stl_inst_1, stl_inst> (stl_cur_1->gen_acos (cast<stl_inst, stl_inst_1> (arg_1)));
}

stl_inst_1
atan (stl_inst_1 arg_1) {
  return cast<stl_inst_1, stl_inst> (stl_cur_1->gen_atan (cast<stl_inst, stl_inst_1> (arg_1)));
}

stl_inst_1
atan2 (stl_inst_1 arg_1, stl_inst_1 arg_2) {
  return cast<stl_inst_1, stl_inst> (stl_cur_1->gen_atan2 (cast<stl_inst, stl_inst_1> (arg_1), cast<stl_inst, stl_inst_1> (arg_2)));
}

stl_inst_1
hypot (stl_inst_1 arg_1, stl_inst_1 arg_2) {
  return cast<stl_inst_1, stl_inst> (stl_cur_1->gen_hypot (cast<stl_inst, stl_inst_1> (arg_1), cast<stl_inst, stl_inst_1> (arg_2)));
}

struct stl_int_rep: stl_type_rep {
  inline stl_int_rep (): stl_type_rep () {}
};

stl_type
stl_int () {
  return new stl_int_rep ();
}

struct stl_double_rep: stl_type_rep {
  inline stl_double_rep (): stl_type_rep () {}
  stl_inst gen_minus (stl_inst);
  stl_inst gen_plus (stl_inst, stl_inst);
  stl_inst gen_minus (stl_inst, stl_inst);
  stl_inst gen_times (stl_inst, stl_inst);
  stl_inst gen_over (stl_inst, stl_inst);
  stl_inst gen_pow (stl_inst, int);
  stl_inst gen_pow (stl_inst, stl_inst);
  stl_inst &gen_plusassign (stl_inst&, stl_inst);
  stl_inst &gen_minusassign (stl_inst&, stl_inst);
  stl_inst &gen_timesassign (stl_inst&, stl_inst);
  stl_inst &gen_overassign (stl_inst&, stl_inst);
  bool gen_equal (stl_inst, stl_inst);
  bool gen_unequal (stl_inst, stl_inst);
  bool gen_less (stl_inst, stl_inst);
  bool gen_lesseq (stl_inst, stl_inst);
  bool gen_gtr (stl_inst, stl_inst);
  bool gen_gtreq (stl_inst, stl_inst);
  stl_inst gen_abs (stl_inst);
  stl_inst gen_sqrt (stl_inst);
  stl_inst gen_exp (stl_inst);
  stl_inst gen_log (stl_inst);
  stl_inst gen_sin (stl_inst);
  stl_inst gen_cos (stl_inst);
  stl_inst gen_tan (stl_inst);
  stl_inst gen_sinh (stl_inst);
  stl_inst gen_cosh (stl_inst);
  stl_inst gen_tanh (stl_inst);
  stl_inst gen_asin (stl_inst);
  stl_inst gen_acos (stl_inst);
  stl_inst gen_atan (stl_inst);
  stl_inst gen_atan2 (stl_inst, stl_inst);
  stl_inst gen_hypot (stl_inst, stl_inst);
};

stl_type
stl_double () {
  return new stl_double_rep ();
}

stl_inst
stl_double_rep::gen_minus (stl_inst arg_1) {
  return convert<stl_inst, double> (-convert<double, stl_inst> (arg_1));
}

stl_inst
stl_double_rep::gen_plus (stl_inst arg_1, stl_inst arg_2) {
  return convert<stl_inst, double> (convert<double, stl_inst> (arg_1) + convert<double, stl_inst> (arg_2));
}

stl_inst
stl_double_rep::gen_minus (stl_inst arg_1, stl_inst arg_2) {
  return convert<stl_inst, double> (convert<double, stl_inst> (arg_1) - convert<double, stl_inst> (arg_2));
}

stl_inst
stl_double_rep::gen_times (stl_inst arg_1, stl_inst arg_2) {
  return convert<stl_inst, double> (convert<double, stl_inst> (arg_1) * convert<double, stl_inst> (arg_2));
}

stl_inst
stl_double_rep::gen_over (stl_inst arg_1, stl_inst arg_2) {
  return convert<stl_inst, double> (convert<double, stl_inst> (arg_1) / convert<double, stl_inst> (arg_2));
}

stl_inst
stl_double_rep::gen_pow (stl_inst arg_1, int arg_2) {
  return convert<stl_inst, double> (pow (convert<double, stl_inst> (arg_1), arg_2));
}

stl_inst
stl_double_rep::gen_pow (stl_inst arg_1, stl_inst arg_2) {
  return convert<stl_inst, double> (pow (convert<double, stl_inst> (arg_1), convert<double, stl_inst> (arg_2)));
}

stl_inst
&stl_double_rep::gen_plusassign (stl_inst &arg_1, stl_inst arg_2) {
  return convert<stl_inst&, double& > (convert<double&, stl_inst& > (arg_1) += convert<double, stl_inst> (arg_2));
}

stl_inst
&stl_double_rep::gen_minusassign (stl_inst &arg_1, stl_inst arg_2) {
  return convert<stl_inst&, double& > (convert<double&, stl_inst& > (arg_1) -= convert<double, stl_inst> (arg_2));
}

stl_inst
&stl_double_rep::gen_timesassign (stl_inst &arg_1, stl_inst arg_2) {
  return convert<stl_inst&, double& > (convert<double&, stl_inst& > (arg_1) *= convert<double, stl_inst> (arg_2));
}

stl_inst
&stl_double_rep::gen_overassign (stl_inst &arg_1, stl_inst arg_2) {
  return convert<stl_inst&, double& > (convert<double&, stl_inst& > (arg_1) /= convert<double, stl_inst> (arg_2));
}

bool
stl_double_rep::gen_equal (stl_inst arg_1, stl_inst arg_2) {
  return convert<double, stl_inst> (arg_1) == convert<double, stl_inst> (arg_2);
}

bool
stl_double_rep::gen_unequal (stl_inst arg_1, stl_inst arg_2) {
  return convert<double, stl_inst> (arg_1) != convert<double, stl_inst> (arg_2);
}

bool
stl_double_rep::gen_less (stl_inst arg_1, stl_inst arg_2) {
  return convert<double, stl_inst> (arg_1) < convert<double, stl_inst> (arg_2);
}

bool
stl_double_rep::gen_lesseq (stl_inst arg_1, stl_inst arg_2) {
  return convert<double, stl_inst> (arg_1) <= convert<double, stl_inst> (arg_2);
}

bool
stl_double_rep::gen_gtr (stl_inst arg_1, stl_inst arg_2) {
  return convert<double, stl_inst> (arg_1) > convert<double, stl_inst> (arg_2);
}

bool
stl_double_rep::gen_gtreq (stl_inst arg_1, stl_inst arg_2) {
  return convert<double, stl_inst> (arg_1) >= convert<double, stl_inst> (arg_2);
}

stl_inst
stl_double_rep::gen_abs (stl_inst arg_1) {
  return convert<stl_inst, double> (abs (convert<double, stl_inst> (arg_1)));
}

stl_inst
stl_double_rep::gen_sqrt (stl_inst arg_1) {
  return convert<stl_inst, double> (sqrt (convert<double, stl_inst> (arg_1)));
}

stl_inst
stl_double_rep::gen_exp (stl_inst arg_1) {
  return convert<stl_inst, double> (exp (convert<double, stl_inst> (arg_1)));
}

stl_inst
stl_double_rep::gen_log (stl_inst arg_1) {
  return convert<stl_inst, double> (log (convert<double, stl_inst> (arg_1)));
}

stl_inst
stl_double_rep::gen_sin (stl_inst arg_1) {
  return convert<stl_inst, double> (sin (convert<double, stl_inst> (arg_1)));
}

stl_inst
stl_double_rep::gen_cos (stl_inst arg_1) {
  return convert<stl_inst, double> (cos (convert<double, stl_inst> (arg_1)));
}

stl_inst
stl_double_rep::gen_tan (stl_inst arg_1) {
  return convert<stl_inst, double> (tan (convert<double, stl_inst> (arg_1)));
}

stl_inst
stl_double_rep::gen_sinh (stl_inst arg_1) {
  return convert<stl_inst, double> (sinh (convert<double, stl_inst> (arg_1)));
}

stl_inst
stl_double_rep::gen_cosh (stl_inst arg_1) {
  return convert<stl_inst, double> (cosh (convert<double, stl_inst> (arg_1)));
}

stl_inst
stl_double_rep::gen_tanh (stl_inst arg_1) {
  return convert<stl_inst, double> (tanh (convert<double, stl_inst> (arg_1)));
}

stl_inst
stl_double_rep::gen_asin (stl_inst arg_1) {
  return convert<stl_inst, double> (asin (convert<double, stl_inst> (arg_1)));
}

stl_inst
stl_double_rep::gen_acos (stl_inst arg_1) {
  return convert<stl_inst, double> (acos (convert<double, stl_inst> (arg_1)));
}

stl_inst
stl_double_rep::gen_atan (stl_inst arg_1) {
  return convert<stl_inst, double> (atan (convert<double, stl_inst> (arg_1)));
}

stl_inst
stl_double_rep::gen_atan2 (stl_inst arg_1, stl_inst arg_2) {
  return convert<stl_inst, double> (atan2 (convert<double, stl_inst> (arg_1), convert<double, stl_inst> (arg_2)));
}

stl_inst
stl_double_rep::gen_hypot (stl_inst arg_1, stl_inst arg_2) {
  return convert<stl_inst, double> (hypot (convert<double, stl_inst> (arg_1), convert<double, stl_inst> (arg_2)));
}

struct stl_complex_rep: stl_type_rep {
  stl_type x_1;
  inline stl_complex_rep (stl_type y_1): stl_type_rep (), x_1 (y_1) {}
  stl_inst gen_minus (stl_inst);
  stl_inst gen_plus (stl_inst, stl_inst);
  stl_inst gen_minus (stl_inst, stl_inst);
  stl_inst gen_times (stl_inst, stl_inst);
  stl_inst gen_over (stl_inst, stl_inst);
  stl_inst gen_pow (stl_inst, int);
  stl_inst gen_pow (stl_inst, stl_inst);
  stl_inst &gen_plusassign (stl_inst&, stl_inst);
  stl_inst &gen_minusassign (stl_inst&, stl_inst);
  stl_inst &gen_timesassign (stl_inst&, stl_inst);
  stl_inst &gen_overassign (stl_inst&, stl_inst);
  bool gen_equal (stl_inst, stl_inst);
  bool gen_unequal (stl_inst, stl_inst);
  stl_inst gen_abs (stl_inst);
  stl_inst gen_sqrt (stl_inst);
  stl_inst gen_exp (stl_inst);
  stl_inst gen_log (stl_inst);
  stl_inst gen_sin (stl_inst);
  stl_inst gen_cos (stl_inst);
  stl_inst gen_sinh (stl_inst);
  stl_inst gen_cosh (stl_inst);
};

stl_type
stl_complex (stl_type x_1) {
  return new stl_complex_rep (x_1);
}

stl_inst
stl_complex_rep::gen_minus (stl_inst arg_1) {
  stl_type save_1 = stl_cur_1;
  stl_cur_1 = x_1;
  stl_inst ret = convert<stl_inst, complex<stl_inst_1> > (-convert<complex<stl_inst_1>, stl_inst> (arg_1));
  stl_cur_1 = save_1;
  return ret;
}

stl_inst
stl_complex_rep::gen_plus (stl_inst arg_1, stl_inst arg_2) {
  stl_type save_1 = stl_cur_1;
  stl_cur_1 = x_1;
  stl_inst ret = convert<stl_inst, complex<stl_inst_1> > (convert<complex<stl_inst_1>, stl_inst> (arg_1) + convert<complex<stl_inst_1>, stl_inst> (arg_2));
  stl_cur_1 = save_1;
  return ret;
}

stl_inst
stl_complex_rep::gen_minus (stl_inst arg_1, stl_inst arg_2) {
  stl_type save_1 = stl_cur_1;
  stl_cur_1 = x_1;
  stl_inst ret = convert<stl_inst, complex<stl_inst_1> > (convert<complex<stl_inst_1>, stl_inst> (arg_1) - convert<complex<stl_inst_1>, stl_inst> (arg_2));
  stl_cur_1 = save_1;
  return ret;
}

stl_inst
stl_complex_rep::gen_times (stl_inst arg_1, stl_inst arg_2) {
  stl_type save_1 = stl_cur_1;
  stl_cur_1 = x_1;
  stl_inst ret = convert<stl_inst, complex<stl_inst_1> > (convert<complex<stl_inst_1>, stl_inst> (arg_1) * convert<complex<stl_inst_1>, stl_inst> (arg_2));
  stl_cur_1 = save_1;
  return ret;
}

stl_inst
stl_complex_rep::gen_over (stl_inst arg_1, stl_inst arg_2) {
  stl_type save_1 = stl_cur_1;
  stl_cur_1 = x_1;
  stl_inst ret = convert<stl_inst, complex<stl_inst_1> > (convert<complex<stl_inst_1>, stl_inst> (arg_1) / convert<complex<stl_inst_1>, stl_inst> (arg_2));
  stl_cur_1 = save_1;
  return ret;
}

stl_inst
stl_complex_rep::gen_pow (stl_inst arg_1, int arg_2) {
  stl_type save_1 = stl_cur_1;
  stl_cur_1 = x_1;
  stl_inst ret = convert<stl_inst, complex<stl_inst_1> > (pow (convert<complex<stl_inst_1>, stl_inst> (arg_1), arg_2));
  stl_cur_1 = save_1;
  return ret;
}

stl_inst
stl_complex_rep::gen_pow (stl_inst arg_1, stl_inst arg_2) {
  stl_type save_1 = stl_cur_1;
  stl_cur_1 = x_1;
  stl_inst ret = convert<stl_inst, complex<stl_inst_1> > (pow (convert<complex<stl_inst_1>, stl_inst> (arg_1), convert<complex<stl_inst_1>, stl_inst> (arg_2)));
  stl_cur_1 = save_1;
  return ret;
}

stl_inst
&stl_complex_rep::gen_plusassign (stl_inst &arg_1, stl_inst arg_2) {
  stl_type save_1 = stl_cur_1;
  stl_cur_1 = x_1;
  stl_inst &ret = convert<stl_inst&, complex<stl_inst_1>& > (convert<complex<stl_inst_1>&, stl_inst& > (arg_1) += convert<complex<stl_inst_1>, stl_inst> (arg_2));
  stl_cur_1 = save_1;
  return ret;
}

stl_inst
&stl_complex_rep::gen_minusassign (stl_inst &arg_1, stl_inst arg_2) {
  stl_type save_1 = stl_cur_1;
  stl_cur_1 = x_1;
  stl_inst &ret = convert<stl_inst&, complex<stl_inst_1>& > (convert<complex<stl_inst_1>&, stl_inst& > (arg_1) -= convert<complex<stl_inst_1>, stl_inst> (arg_2));
  stl_cur_1 = save_1;
  return ret;
}

stl_inst
&stl_complex_rep::gen_timesassign (stl_inst &arg_1, stl_inst arg_2) {
  stl_type save_1 = stl_cur_1;
  stl_cur_1 = x_1;
  stl_inst &ret = convert<stl_inst&, complex<stl_inst_1>& > (convert<complex<stl_inst_1>&, stl_inst& > (arg_1) *= convert<complex<stl_inst_1>, stl_inst> (arg_2));
  stl_cur_1 = save_1;
  return ret;
}

stl_inst
&stl_complex_rep::gen_overassign (stl_inst &arg_1, stl_inst arg_2) {
  stl_type save_1 = stl_cur_1;
  stl_cur_1 = x_1;
  stl_inst &ret = convert<stl_inst&, complex<stl_inst_1>& > (convert<complex<stl_inst_1>&, stl_inst& > (arg_1) /= convert<complex<stl_inst_1>, stl_inst> (arg_2));
  stl_cur_1 = save_1;
  return ret;
}

bool
stl_complex_rep::gen_equal (stl_inst arg_1, stl_inst arg_2) {
  stl_type save_1 = stl_cur_1;
  stl_cur_1 = x_1;
  bool ret = convert<complex<stl_inst_1>, stl_inst> (arg_1) == convert<complex<stl_inst_1>, stl_inst> (arg_2);
  stl_cur_1 = save_1;
  return ret;
}

bool
stl_complex_rep::gen_unequal (stl_inst arg_1, stl_inst arg_2) {
  stl_type save_1 = stl_cur_1;
  stl_cur_1 = x_1;
  bool ret = convert<complex<stl_inst_1>, stl_inst> (arg_1) != convert<complex<stl_inst_1>, stl_inst> (arg_2);
  stl_cur_1 = save_1;
  return ret;
}

stl_inst
stl_complex_rep::gen_abs (stl_inst arg_1) {
  stl_type save_1 = stl_cur_1;
  stl_cur_1 = x_1;
  stl_inst ret = convert<stl_inst, complex<stl_inst_1> > (abs (convert<complex<stl_inst_1>, stl_inst> (arg_1)));
  stl_cur_1 = save_1;
  return ret;
}

stl_inst
stl_complex_rep::gen_sqrt (stl_inst arg_1) {
  stl_type save_1 = stl_cur_1;
  stl_cur_1 = x_1;
  stl_inst ret = convert<stl_inst, complex<stl_inst_1> > (sqrt (convert<complex<stl_inst_1>, stl_inst> (arg_1)));
  stl_cur_1 = save_1;
  return ret;
}

stl_inst
stl_complex_rep::gen_exp (stl_inst arg_1) {
  stl_type save_1 = stl_cur_1;
  stl_cur_1 = x_1;
  stl_inst ret = convert<stl_inst, complex<stl_inst_1> > (exp (convert<complex<stl_inst_1>, stl_inst> (arg_1)));
  stl_cur_1 = save_1;
  return ret;
}

stl_inst
stl_complex_rep::gen_log (stl_inst arg_1) {
  stl_type save_1 = stl_cur_1;
  stl_cur_1 = x_1;
  stl_inst ret = convert<stl_inst, complex<stl_inst_1> > (log (convert<complex<stl_inst_1>, stl_inst> (arg_1)));
  stl_cur_1 = save_1;
  return ret;
}

stl_inst
stl_complex_rep::gen_sin (stl_inst arg_1) {
  stl_type save_1 = stl_cur_1;
  stl_cur_1 = x_1;
  stl_inst ret = convert<stl_inst, complex<stl_inst_1> > (sin (convert<complex<stl_inst_1>, stl_inst> (arg_1)));
  stl_cur_1 = save_1;
  return ret;
}

stl_inst
stl_complex_rep::gen_cos (stl_inst arg_1) {
  stl_type save_1 = stl_cur_1;
  stl_cur_1 = x_1;
  stl_inst ret = convert<stl_inst, complex<stl_inst_1> > (cos (convert<complex<stl_inst_1>, stl_inst> (arg_1)));
  stl_cur_1 = save_1;
  return ret;
}

stl_inst
stl_complex_rep::gen_sinh (stl_inst arg_1) {
  stl_type save_1 = stl_cur_1;
  stl_cur_1 = x_1;
  stl_inst ret = convert<stl_inst, complex<stl_inst_1> > (sinh (convert<complex<stl_inst_1>, stl_inst> (arg_1)));
  stl_cur_1 = save_1;
  return ret;
}

stl_inst
stl_complex_rep::gen_cosh (stl_inst arg_1) {
  stl_type save_1 = stl_cur_1;
  stl_cur_1 = x_1;
  stl_inst ret = convert<stl_inst, complex<stl_inst_1> > (cosh (convert<complex<stl_inst_1>, stl_inst> (arg_1)));
  stl_cur_1 = save_1;
  return ret;
}

struct stl_vector_rep: stl_type_rep {
  stl_type x_1;
  inline stl_vector_rep (stl_type y_1): stl_type_rep (), x_1 (y_1) {}
  bool gen_equal (stl_inst, stl_inst);
  bool gen_unequal (stl_inst, stl_inst);
  bool gen_less (stl_inst, stl_inst);
  bool gen_lesseq (stl_inst, stl_inst);
  bool gen_gtr (stl_inst, stl_inst);
  bool gen_gtreq (stl_inst, stl_inst);
};

stl_type
stl_vector (stl_type x_1) {
  return new stl_vector_rep (x_1);
}

bool
stl_vector_rep::gen_equal (stl_inst arg_1, stl_inst arg_2) {
  stl_type save_1 = stl_cur_1;
  stl_cur_1 = x_1;
  bool ret = convert<vector<stl_inst_1>, stl_inst> (arg_1) == convert<vector<stl_inst_1>, stl_inst> (arg_2);
  stl_cur_1 = save_1;
  return ret;
}

bool
stl_vector_rep::gen_unequal (stl_inst arg_1, stl_inst arg_2) {
  stl_type save_1 = stl_cur_1;
  stl_cur_1 = x_1;
  bool ret = convert<vector<stl_inst_1>, stl_inst> (arg_1) != convert<vector<stl_inst_1>, stl_inst> (arg_2);
  stl_cur_1 = save_1;
  return ret;
}

bool
stl_vector_rep::gen_less (stl_inst arg_1, stl_inst arg_2) {
  stl_type save_1 = stl_cur_1;
  stl_cur_1 = x_1;
  bool ret = convert<vector<stl_inst_1>, stl_inst> (arg_1) < convert<vector<stl_inst_1>, stl_inst> (arg_2);
  stl_cur_1 = save_1;
  return ret;
}

bool
stl_vector_rep::gen_lesseq (stl_inst arg_1, stl_inst arg_2) {
  stl_type save_1 = stl_cur_1;
  stl_cur_1 = x_1;
  bool ret = convert<vector<stl_inst_1>, stl_inst> (arg_1) <= convert<vector<stl_inst_1>, stl_inst> (arg_2);
  stl_cur_1 = save_1;
  return ret;
}

bool
stl_vector_rep::gen_gtr (stl_inst arg_1, stl_inst arg_2) {
  stl_type save_1 = stl_cur_1;
  stl_cur_1 = x_1;
  bool ret = convert<vector<stl_inst_1>, stl_inst> (arg_1) > convert<vector<stl_inst_1>, stl_inst> (arg_2);
  stl_cur_1 = save_1;
  return ret;
}

bool
stl_vector_rep::gen_gtreq (stl_inst arg_1, stl_inst arg_2) {
  stl_type save_1 = stl_cur_1;
  stl_cur_1 = x_1;
  bool ret = convert<vector<stl_inst_1>, stl_inst> (arg_1) >= convert<vector<stl_inst_1>, stl_inst> (arg_2);
  stl_cur_1 = save_1;
  return ret;
}

struct stl_slist_rep: stl_type_rep {
  stl_type x_1;
  inline stl_slist_rep (stl_type y_1): stl_type_rep (), x_1 (y_1) {}
  bool gen_equal (stl_inst, stl_inst);
  bool gen_unequal (stl_inst, stl_inst);
  bool gen_less (stl_inst, stl_inst);
  bool gen_lesseq (stl_inst, stl_inst);
  bool gen_gtr (stl_inst, stl_inst);
  bool gen_gtreq (stl_inst, stl_inst);
};

stl_type
stl_slist (stl_type x_1) {
  return new stl_slist_rep (x_1);
}

bool
stl_slist_rep::gen_equal (stl_inst arg_1, stl_inst arg_2) {
  stl_type save_1 = stl_cur_1;
  stl_cur_1 = x_1;
  bool ret = convert<slist<stl_inst_1>, stl_inst> (arg_1) == convert<slist<stl_inst_1>, stl_inst> (arg_2);
  stl_cur_1 = save_1;
  return ret;
}

bool
stl_slist_rep::gen_unequal (stl_inst arg_1, stl_inst arg_2) {
  stl_type save_1 = stl_cur_1;
  stl_cur_1 = x_1;
  bool ret = convert<slist<stl_inst_1>, stl_inst> (arg_1) != convert<slist<stl_inst_1>, stl_inst> (arg_2);
  stl_cur_1 = save_1;
  return ret;
}

bool
stl_slist_rep::gen_less (stl_inst arg_1, stl_inst arg_2) {
  stl_type save_1 = stl_cur_1;
  stl_cur_1 = x_1;
  bool ret = convert<slist<stl_inst_1>, stl_inst> (arg_1) < convert<slist<stl_inst_1>, stl_inst> (arg_2);
  stl_cur_1 = save_1;
  return ret;
}

bool
stl_slist_rep::gen_lesseq (stl_inst arg_1, stl_inst arg_2) {
  stl_type save_1 = stl_cur_1;
  stl_cur_1 = x_1;
  bool ret = convert<slist<stl_inst_1>, stl_inst> (arg_1) <= convert<slist<stl_inst_1>, stl_inst> (arg_2);
  stl_cur_1 = save_1;
  return ret;
}

bool
stl_slist_rep::gen_gtr (stl_inst arg_1, stl_inst arg_2) {
  stl_type save_1 = stl_cur_1;
  stl_cur_1 = x_1;
  bool ret = convert<slist<stl_inst_1>, stl_inst> (arg_1) > convert<slist<stl_inst_1>, stl_inst> (arg_2);
  stl_cur_1 = save_1;
  return ret;
}

bool
stl_slist_rep::gen_gtreq (stl_inst arg_1, stl_inst arg_2) {
  stl_type save_1 = stl_cur_1;
  stl_cur_1 = x_1;
  bool ret = convert<slist<stl_inst_1>, stl_inst> (arg_1) >= convert<slist<stl_inst_1>, stl_inst> (arg_2);
  stl_cur_1 = save_1;
  return ret;
}

struct stl_valarray_rep: stl_type_rep {
  stl_type x_1;
  inline stl_valarray_rep (stl_type y_1): stl_type_rep (), x_1 (y_1) {}
  stl_inst gen_minus (stl_inst);
  stl_inst gen_plus (stl_inst, stl_inst);
  stl_inst gen_minus (stl_inst, stl_inst);
  stl_inst gen_times (stl_inst, stl_inst);
  stl_inst gen_over (stl_inst, stl_inst);
  stl_inst &gen_plusassign (stl_inst&, stl_inst);
  stl_inst &gen_minusassign (stl_inst&, stl_inst);
  stl_inst &gen_timesassign (stl_inst&, stl_inst);
  stl_inst &gen_overassign (stl_inst&, stl_inst);
};

stl_type
stl_valarray (stl_type x_1) {
  return new stl_valarray_rep (x_1);
}

stl_inst
stl_valarray_rep::gen_minus (stl_inst arg_1) {
  stl_type save_1 = stl_cur_1;
  stl_cur_1 = x_1;
  stl_inst ret = convert<stl_inst, valarray<stl_inst_1> > (-convert<valarray<stl_inst_1>, stl_inst> (arg_1));
  stl_cur_1 = save_1;
  return ret;
}

stl_inst
stl_valarray_rep::gen_plus (stl_inst arg_1, stl_inst arg_2) {
  stl_type save_1 = stl_cur_1;
  stl_cur_1 = x_1;
  stl_inst ret = convert<stl_inst, valarray<stl_inst_1> > (convert<valarray<stl_inst_1>, stl_inst> (arg_1) + convert<valarray<stl_inst_1>, stl_inst> (arg_2));
  stl_cur_1 = save_1;
  return ret;
}

stl_inst
stl_valarray_rep::gen_minus (stl_inst arg_1, stl_inst arg_2) {
  stl_type save_1 = stl_cur_1;
  stl_cur_1 = x_1;
  stl_inst ret = convert<stl_inst, valarray<stl_inst_1> > (convert<valarray<stl_inst_1>, stl_inst> (arg_1) - convert<valarray<stl_inst_1>, stl_inst> (arg_2));
  stl_cur_1 = save_1;
  return ret;
}

stl_inst
stl_valarray_rep::gen_times (stl_inst arg_1, stl_inst arg_2) {
  stl_type save_1 = stl_cur_1;
  stl_cur_1 = x_1;
  stl_inst ret = convert<stl_inst, valarray<stl_inst_1> > (convert<valarray<stl_inst_1>, stl_inst> (arg_1) * convert<valarray<stl_inst_1>, stl_inst> (arg_2));
  stl_cur_1 = save_1;
  return ret;
}

stl_inst
stl_valarray_rep::gen_over (stl_inst arg_1, stl_inst arg_2) {
  stl_type save_1 = stl_cur_1;
  stl_cur_1 = x_1;
  stl_inst ret = convert<stl_inst, valarray<stl_inst_1> > (convert<valarray<stl_inst_1>, stl_inst> (arg_1) / convert<valarray<stl_inst_1>, stl_inst> (arg_2));
  stl_cur_1 = save_1;
  return ret;
}

stl_inst
&stl_valarray_rep::gen_plusassign (stl_inst &arg_1, stl_inst arg_2) {
  stl_type save_1 = stl_cur_1;
  stl_cur_1 = x_1;
  stl_inst &ret = convert<stl_inst&, valarray<stl_inst_1>& > (convert<valarray<stl_inst_1>&, stl_inst& > (arg_1) += convert<valarray<stl_inst_1>, stl_inst> (arg_2));
  stl_cur_1 = save_1;
  return ret;
}

stl_inst
&stl_valarray_rep::gen_minusassign (stl_inst &arg_1, stl_inst arg_2) {
  stl_type save_1 = stl_cur_1;
  stl_cur_1 = x_1;
  stl_inst &ret = convert<stl_inst&, valarray<stl_inst_1>& > (convert<valarray<stl_inst_1>&, stl_inst& > (arg_1) -= convert<valarray<stl_inst_1>, stl_inst> (arg_2));
  stl_cur_1 = save_1;
  return ret;
}

stl_inst
&stl_valarray_rep::gen_timesassign (stl_inst &arg_1, stl_inst arg_2) {
  stl_type save_1 = stl_cur_1;
  stl_cur_1 = x_1;
  stl_inst &ret = convert<stl_inst&, valarray<stl_inst_1>& > (convert<valarray<stl_inst_1>&, stl_inst& > (arg_1) *= convert<valarray<stl_inst_1>, stl_inst> (arg_2));
  stl_cur_1 = save_1;
  return ret;
}

stl_inst
&stl_valarray_rep::gen_overassign (stl_inst &arg_1, stl_inst arg_2) {
  stl_type save_1 = stl_cur_1;
  stl_cur_1 = x_1;
  stl_inst &ret = convert<stl_inst&, valarray<stl_inst_1>& > (convert<valarray<stl_inst_1>&, stl_inst& > (arg_1) /= convert<valarray<stl_inst_1>, stl_inst> (arg_2));
  stl_cur_1 = save_1;
  return ret;
}

#include "config.hh"
#include "generic.hh"
#include "list.hh"
#include "string.hh"
#include "gentable.hh"
#include "table.hh"
#include "symbol.hh"
#include "single.hh"
#include "printer.hh"
#include "literal.hh"
#include "alias.hh"
#include "mirror.hh"
#include "value.hh"
#include "symbols.hh"
#include "glued.hh"

static mmx::generic ID_1 = mmx::mirror (mmx::symbol ("Int"));
static mmx::generic ID_2 = mmx::mirror (mmx::symbol ("Double"));
static mmx::generic ID_3 = mmx::mirror (mmx::symbol ("Complex"));

static mmx::generic
FUN_3 (mmx::generic g) {
  return cons (ID_3, cdr (as_list (g)));
}

static mmx::generic ID_4 = mmx::mirror (mmx::symbol ("Vector"));

static mmx::generic
FUN_4 (mmx::generic g) {
  return cons (ID_4, cdr (as_list (g)));
}

static mmx::generic ID_5 = mmx::mirror (mmx::symbol ("SList"));

static mmx::generic
FUN_5 (mmx::generic g) {
  return cons (ID_5, cdr (as_list (g)));
}

static mmx::generic ID_6 = mmx::mirror (mmx::symbol ("Valarray"));

static mmx::generic
FUN_6 (mmx::generic g) {
  return cons (ID_6, cdr (as_list (g)));
}

static mmx::generic
FUN_7 (mmx::generic g) {
  return mmx::glued<double> (-mmx::view_as<double> (g[1]));
}

static mmx::generic
FUN_8 (mmx::generic g) {
  return mmx::glued<double> (mmx::view_as<double> (g[1]) + mmx::view_as<double> (g[2]));
}

static mmx::generic
FUN_9 (mmx::generic g) {
  return mmx::glued<double> (mmx::view_as<double> (g[1]) - mmx::view_as<double> (g[2]));
}

static mmx::generic
FUN_10 (mmx::generic g) {
  return mmx::glued<double> (mmx::view_as<double> (g[1]) * mmx::view_as<double> (g[2]));
}

static mmx::generic
FUN_11 (mmx::generic g) {
  return mmx::glued<double> (mmx::view_as<double> (g[1]) / mmx::view_as<double> (g[2]));
}

static mmx::generic
FUN_12 (mmx::generic g) {
  return mmx::glued<double> (pow (mmx::view_as<double> (g[1]), mmx::as_int (g[2])));
}

static mmx::generic
FUN_13 (mmx::generic g) {
  return mmx::glued<double> (pow (mmx::view_as<double> (g[1]), mmx::view_as<double> (g[2])));
}

static mmx::generic
FUN_14 (mmx::generic g) {
  return mmx::glued_alias<double> (mmx::view_as_alias<double> (g[1]) += mmx::view_as<double> (g[2]));
}

static mmx::generic
FUN_15 (mmx::generic g) {
  return mmx::glued_alias<double> (mmx::view_as_alias<double> (g[1]) -= mmx::view_as<double> (g[2]));
}

static mmx::generic
FUN_16 (mmx::generic g) {
  return mmx::glued_alias<double> (mmx::view_as_alias<double> (g[1]) *= mmx::view_as<double> (g[2]));
}

static mmx::generic
FUN_17 (mmx::generic g) {
  return mmx::glued_alias<double> (mmx::view_as_alias<double> (g[1]) /= mmx::view_as<double> (g[2]));
}

static mmx::generic
FUN_18 (mmx::generic g) {
  return mmx::single (mmx::view_as<double> (g[1]) == mmx::view_as<double> (g[2]));
}

static mmx::generic
FUN_19 (mmx::generic g) {
  return mmx::single (mmx::view_as<double> (g[1]) != mmx::view_as<double> (g[2]));
}

static mmx::generic
FUN_20 (mmx::generic g) {
  return mmx::single (mmx::view_as<double> (g[1]) < mmx::view_as<double> (g[2]));
}

static mmx::generic
FUN_21 (mmx::generic g) {
  return mmx::single (mmx::view_as<double> (g[1]) <= mmx::view_as<double> (g[2]));
}

static mmx::generic
FUN_22 (mmx::generic g) {
  return mmx::single (mmx::view_as<double> (g[1]) > mmx::view_as<double> (g[2]));
}

static mmx::generic
FUN_23 (mmx::generic g) {
  return mmx::single (mmx::view_as<double> (g[1]) >= mmx::view_as<double> (g[2]));
}

static mmx::generic
FUN_24 (mmx::generic g) {
  return mmx::glued<double> (fabs (mmx::view_as<double> (g[1])));
}

static mmx::generic
FUN_25 (mmx::generic g) {
  return mmx::glued<double> (sqrt (mmx::view_as<double> (g[1])));
}

static mmx::generic
FUN_26 (mmx::generic g) {
  return mmx::glued<double> (exp (mmx::view_as<double> (g[1])));
}

static mmx::generic
FUN_27 (mmx::generic g) {
  return mmx::glued<double> (log (mmx::view_as<double> (g[1])));
}

static mmx::generic
FUN_28 (mmx::generic g) {
  return mmx::glued<double> (sin (mmx::view_as<double> (g[1])));
}

static mmx::generic
FUN_29 (mmx::generic g) {
  return mmx::glued<double> (cos (mmx::view_as<double> (g[1])));
}

static mmx::generic
FUN_30 (mmx::generic g) {
  return mmx::glued<double> (tan (mmx::view_as<double> (g[1])));
}

static mmx::generic
FUN_31 (mmx::generic g) {
  return mmx::glued<double> (sinh (mmx::view_as<double> (g[1])));
}

static mmx::generic
FUN_32 (mmx::generic g) {
  return mmx::glued<double> (cosh (mmx::view_as<double> (g[1])));
}

static mmx::generic
FUN_33 (mmx::generic g) {
  return mmx::glued<double> (tanh (mmx::view_as<double> (g[1])));
}

static mmx::generic
FUN_34 (mmx::generic g) {
  return mmx::glued<double> (asin (mmx::view_as<double> (g[1])));
}

static mmx::generic
FUN_35 (mmx::generic g) {
  return mmx::glued<double> (acos (mmx::view_as<double> (g[1])));
}

static mmx::generic
FUN_36 (mmx::generic g) {
  return mmx::glued<double> (atan (mmx::view_as<double> (g[1])));
}

static mmx::generic
FUN_37 (mmx::generic g) {
  return mmx::glued<double> (floor (mmx::view_as<double> (g[1])));
}

static mmx::generic
FUN_38 (mmx::generic g) {
  return mmx::glued<double> (ceil (mmx::view_as<double> (g[1])));
}

static mmx::generic
FUN_39 (mmx::generic g) {
  return mmx::glued<double> (atan2 (mmx::view_as<double> (g[1]), mmx::view_as<double> (g[2])));
}

static mmx::generic
FUN_40 (mmx::generic g) {
  return mmx::glued<double> (hypot (mmx::view_as<double> (g[1]), mmx::view_as<double> (g[2])));
}

static mmx::generic
FUN_41 (mmx::generic g) {
  mmx::generic h = g[0];
  stl_type save_1 = stl_cur_1;
  stl_cur_1 = mmx::view_as<stl_type> (mmx::as_glue_type (g[1]));
  mmx::generic ret = mmx::glued<complex<stl_inst_1> > (-mmx::view_as<complex<stl_inst_1> > (h[1]));
  stl_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_42 (mmx::generic g) {
  mmx::generic h = g[0];
  stl_type save_1 = stl_cur_1;
  stl_cur_1 = mmx::view_as<stl_type> (mmx::as_glue_type (g[1]));
  mmx::generic ret = mmx::glued<complex<stl_inst_1> > (mmx::view_as<complex<stl_inst_1> > (h[1]) + mmx::view_as<complex<stl_inst_1> > (h[2]));
  stl_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_43 (mmx::generic g) {
  mmx::generic h = g[0];
  stl_type save_1 = stl_cur_1;
  stl_cur_1 = mmx::view_as<stl_type> (mmx::as_glue_type (g[1]));
  mmx::generic ret = mmx::glued<complex<stl_inst_1> > (mmx::view_as<complex<stl_inst_1> > (h[1]) - mmx::view_as<complex<stl_inst_1> > (h[2]));
  stl_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_44 (mmx::generic g) {
  mmx::generic h = g[0];
  stl_type save_1 = stl_cur_1;
  stl_cur_1 = mmx::view_as<stl_type> (mmx::as_glue_type (g[1]));
  mmx::generic ret = mmx::glued<complex<stl_inst_1> > (mmx::view_as<complex<stl_inst_1> > (h[1]) * mmx::view_as<complex<stl_inst_1> > (h[2]));
  stl_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_45 (mmx::generic g) {
  mmx::generic h = g[0];
  stl_type save_1 = stl_cur_1;
  stl_cur_1 = mmx::view_as<stl_type> (mmx::as_glue_type (g[1]));
  mmx::generic ret = mmx::glued<complex<stl_inst_1> > (mmx::view_as<complex<stl_inst_1> > (h[1]) / mmx::view_as<complex<stl_inst_1> > (h[2]));
  stl_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_46 (mmx::generic g) {
  mmx::generic h = g[0];
  stl_type save_1 = stl_cur_1;
  stl_cur_1 = mmx::view_as<stl_type> (mmx::as_glue_type (g[1]));
  mmx::generic ret = mmx::glued<complex<stl_inst_1> > (pow (mmx::view_as<complex<stl_inst_1> > (h[1]), mmx::as_int (h[2])));
  stl_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_47 (mmx::generic g) {
  mmx::generic h = g[0];
  stl_type save_1 = stl_cur_1;
  stl_cur_1 = mmx::view_as<stl_type> (mmx::as_glue_type (g[1]));
  mmx::generic ret = mmx::glued<complex<stl_inst_1> > (pow (mmx::view_as<complex<stl_inst_1> > (h[1]), mmx::view_as<stl_inst_1> (h[2])));
  stl_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_48 (mmx::generic g) {
  mmx::generic h = g[0];
  stl_type save_1 = stl_cur_1;
  stl_cur_1 = mmx::view_as<stl_type> (mmx::as_glue_type (g[1]));
  mmx::generic ret = mmx::glued<complex<stl_inst_1> > (pow (mmx::view_as<complex<stl_inst_1> > (h[1]), mmx::view_as<complex<stl_inst_1> > (h[2])));
  stl_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_49 (mmx::generic g) {
  mmx::generic h = g[0];
  stl_type save_1 = stl_cur_1;
  stl_cur_1 = mmx::view_as<stl_type> (mmx::as_glue_type (g[1]));
  mmx::generic ret = mmx::glued_alias<complex<stl_inst_1> > (mmx::view_as_alias<complex<stl_inst_1> > (h[1]) += mmx::view_as<complex<stl_inst_1> > (h[2]));
  stl_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_50 (mmx::generic g) {
  mmx::generic h = g[0];
  stl_type save_1 = stl_cur_1;
  stl_cur_1 = mmx::view_as<stl_type> (mmx::as_glue_type (g[1]));
  mmx::generic ret = mmx::glued_alias<complex<stl_inst_1> > (mmx::view_as_alias<complex<stl_inst_1> > (h[1]) -= mmx::view_as<complex<stl_inst_1> > (h[2]));
  stl_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_51 (mmx::generic g) {
  mmx::generic h = g[0];
  stl_type save_1 = stl_cur_1;
  stl_cur_1 = mmx::view_as<stl_type> (mmx::as_glue_type (g[1]));
  mmx::generic ret = mmx::glued_alias<complex<stl_inst_1> > (mmx::view_as_alias<complex<stl_inst_1> > (h[1]) *= mmx::view_as<complex<stl_inst_1> > (h[2]));
  stl_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_52 (mmx::generic g) {
  mmx::generic h = g[0];
  stl_type save_1 = stl_cur_1;
  stl_cur_1 = mmx::view_as<stl_type> (mmx::as_glue_type (g[1]));
  mmx::generic ret = mmx::glued_alias<complex<stl_inst_1> > (mmx::view_as_alias<complex<stl_inst_1> > (h[1]) /= mmx::view_as<complex<stl_inst_1> > (h[2]));
  stl_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_53 (mmx::generic g) {
  mmx::generic h = g[0];
  stl_type save_1 = stl_cur_1;
  stl_cur_1 = mmx::view_as<stl_type> (mmx::as_glue_type (g[1]));
  mmx::generic ret = mmx::single (mmx::view_as<complex<stl_inst_1> > (h[1]) == mmx::view_as<complex<stl_inst_1> > (h[2]));
  stl_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_54 (mmx::generic g) {
  mmx::generic h = g[0];
  stl_type save_1 = stl_cur_1;
  stl_cur_1 = mmx::view_as<stl_type> (mmx::as_glue_type (g[1]));
  mmx::generic ret = mmx::single (mmx::view_as<complex<stl_inst_1> > (h[1]) != mmx::view_as<complex<stl_inst_1> > (h[2]));
  stl_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_55 (mmx::generic g) {
  mmx::generic h = g[0];
  stl_type save_1 = stl_cur_1;
  stl_cur_1 = mmx::view_as<stl_type> (mmx::as_glue_type (g[1]));
  mmx::generic ret = mmx::glued<complex<stl_inst_1> > (polar (mmx::view_as<stl_inst_1> (h[1]), mmx::view_as<stl_inst_1> (h[2])));
  stl_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_56 (mmx::generic g) {
  mmx::generic h = g[0];
  stl_type save_1 = stl_cur_1;
  stl_cur_1 = mmx::view_as<stl_type> (mmx::as_glue_type (g[1]));
  mmx::generic ret = mmx::glued<complex<stl_inst_1> > (abs (mmx::view_as<complex<stl_inst_1> > (h[1])));
  stl_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_57 (mmx::generic g) {
  mmx::generic h = g[0];
  stl_type save_1 = stl_cur_1;
  stl_cur_1 = mmx::view_as<stl_type> (mmx::as_glue_type (g[1]));
  mmx::generic ret = mmx::glued<complex<stl_inst_1> > (arg (mmx::view_as<complex<stl_inst_1> > (h[1])));
  stl_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_58 (mmx::generic g) {
  mmx::generic h = g[0];
  stl_type save_1 = stl_cur_1;
  stl_cur_1 = mmx::view_as<stl_type> (mmx::as_glue_type (g[1]));
  mmx::generic ret = mmx::glued<complex<stl_inst_1> > (conj (mmx::view_as<complex<stl_inst_1> > (h[1])));
  stl_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_59 (mmx::generic g) {
  mmx::generic h = g[0];
  stl_type save_1 = stl_cur_1;
  stl_cur_1 = mmx::view_as<stl_type> (mmx::as_glue_type (g[1]));
  mmx::generic ret = mmx::glued<complex<stl_inst_1> > (sqrt (mmx::view_as<complex<stl_inst_1> > (h[1])));
  stl_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_60 (mmx::generic g) {
  mmx::generic h = g[0];
  stl_type save_1 = stl_cur_1;
  stl_cur_1 = mmx::view_as<stl_type> (mmx::as_glue_type (g[1]));
  mmx::generic ret = mmx::glued<complex<stl_inst_1> > (exp (mmx::view_as<complex<stl_inst_1> > (h[1])));
  stl_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_61 (mmx::generic g) {
  mmx::generic h = g[0];
  stl_type save_1 = stl_cur_1;
  stl_cur_1 = mmx::view_as<stl_type> (mmx::as_glue_type (g[1]));
  mmx::generic ret = mmx::glued<complex<stl_inst_1> > (log (mmx::view_as<complex<stl_inst_1> > (h[1])));
  stl_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_62 (mmx::generic g) {
  mmx::generic h = g[0];
  stl_type save_1 = stl_cur_1;
  stl_cur_1 = mmx::view_as<stl_type> (mmx::as_glue_type (g[1]));
  mmx::generic ret = mmx::glued<complex<stl_inst_1> > (sin (mmx::view_as<complex<stl_inst_1> > (h[1])));
  stl_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_63 (mmx::generic g) {
  mmx::generic h = g[0];
  stl_type save_1 = stl_cur_1;
  stl_cur_1 = mmx::view_as<stl_type> (mmx::as_glue_type (g[1]));
  mmx::generic ret = mmx::glued<complex<stl_inst_1> > (cos (mmx::view_as<complex<stl_inst_1> > (h[1])));
  stl_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_64 (mmx::generic g) {
  mmx::generic h = g[0];
  stl_type save_1 = stl_cur_1;
  stl_cur_1 = mmx::view_as<stl_type> (mmx::as_glue_type (g[1]));
  mmx::generic ret = mmx::glued<complex<stl_inst_1> > (sinh (mmx::view_as<complex<stl_inst_1> > (h[1])));
  stl_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_65 (mmx::generic g) {
  mmx::generic h = g[0];
  stl_type save_1 = stl_cur_1;
  stl_cur_1 = mmx::view_as<stl_type> (mmx::as_glue_type (g[1]));
  mmx::generic ret = mmx::glued<complex<stl_inst_1> > (cosh (mmx::view_as<complex<stl_inst_1> > (h[1])));
  stl_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_66 (mmx::generic g) {
  mmx::generic h = g[0];
  stl_type save_1 = stl_cur_1;
  stl_cur_1 = mmx::view_as<stl_type> (mmx::as_glue_type (g[1]));
  mmx::generic ret = mmx::glued<stl_inst_1> (mmx::view_as<vector<stl_inst_1> > (h[1])[mmx::as_int (h[2])]);
  stl_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_67 (mmx::generic g) {
  mmx::generic h = g[0];
  stl_type save_1 = stl_cur_1;
  stl_cur_1 = mmx::view_as<stl_type> (mmx::as_glue_type (g[1]));
  mmx::generic ret = mmx::glued_alias<stl_inst_1> (mmx::view_as_alias<vector<stl_inst_1> > (h[1])[mmx::as_int (h[2])]);
  stl_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_68 (mmx::generic g) {
  mmx::generic h = g[0];
  stl_type save_1 = stl_cur_1;
  stl_cur_1 = mmx::view_as<stl_type> (mmx::as_glue_type (g[1]));
  mmx::generic ret = mmx::single (mmx::view_as<vector<stl_inst_1> > (h[1]) == mmx::view_as<vector<stl_inst_1> > (h[2]));
  stl_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_69 (mmx::generic g) {
  mmx::generic h = g[0];
  stl_type save_1 = stl_cur_1;
  stl_cur_1 = mmx::view_as<stl_type> (mmx::as_glue_type (g[1]));
  mmx::generic ret = mmx::single (mmx::view_as<vector<stl_inst_1> > (h[1]) != mmx::view_as<vector<stl_inst_1> > (h[2]));
  stl_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_70 (mmx::generic g) {
  mmx::generic h = g[0];
  stl_type save_1 = stl_cur_1;
  stl_cur_1 = mmx::view_as<stl_type> (mmx::as_glue_type (g[1]));
  mmx::generic ret = mmx::single (mmx::view_as<vector<stl_inst_1> > (h[1]) < mmx::view_as<vector<stl_inst_1> > (h[2]));
  stl_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_71 (mmx::generic g) {
  mmx::generic h = g[0];
  stl_type save_1 = stl_cur_1;
  stl_cur_1 = mmx::view_as<stl_type> (mmx::as_glue_type (g[1]));
  mmx::generic ret = mmx::single (mmx::view_as<vector<stl_inst_1> > (h[1]) <= mmx::view_as<vector<stl_inst_1> > (h[2]));
  stl_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_72 (mmx::generic g) {
  mmx::generic h = g[0];
  stl_type save_1 = stl_cur_1;
  stl_cur_1 = mmx::view_as<stl_type> (mmx::as_glue_type (g[1]));
  mmx::generic ret = mmx::single (mmx::view_as<vector<stl_inst_1> > (h[1]) > mmx::view_as<vector<stl_inst_1> > (h[2]));
  stl_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_73 (mmx::generic g) {
  mmx::generic h = g[0];
  stl_type save_1 = stl_cur_1;
  stl_cur_1 = mmx::view_as<stl_type> (mmx::as_glue_type (g[1]));
  mmx::generic ret = mmx::single (mmx::view_as<vector<stl_inst_1> > (h[1]) >= mmx::view_as<vector<stl_inst_1> > (h[2]));
  stl_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_74 (mmx::generic g) {
  mmx::generic h = g[0];
  stl_type save_1 = stl_cur_1;
  stl_cur_1 = mmx::view_as<stl_type> (mmx::as_glue_type (g[1]));
  mmx::generic ret = mmx::single (mmx::view_as<slist<stl_inst_1> > (h[1]) == mmx::view_as<slist<stl_inst_1> > (h[2]));
  stl_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_75 (mmx::generic g) {
  mmx::generic h = g[0];
  stl_type save_1 = stl_cur_1;
  stl_cur_1 = mmx::view_as<stl_type> (mmx::as_glue_type (g[1]));
  mmx::generic ret = mmx::single (mmx::view_as<slist<stl_inst_1> > (h[1]) != mmx::view_as<slist<stl_inst_1> > (h[2]));
  stl_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_76 (mmx::generic g) {
  mmx::generic h = g[0];
  stl_type save_1 = stl_cur_1;
  stl_cur_1 = mmx::view_as<stl_type> (mmx::as_glue_type (g[1]));
  mmx::generic ret = mmx::single (mmx::view_as<slist<stl_inst_1> > (h[1]) < mmx::view_as<slist<stl_inst_1> > (h[2]));
  stl_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_77 (mmx::generic g) {
  mmx::generic h = g[0];
  stl_type save_1 = stl_cur_1;
  stl_cur_1 = mmx::view_as<stl_type> (mmx::as_glue_type (g[1]));
  mmx::generic ret = mmx::single (mmx::view_as<slist<stl_inst_1> > (h[1]) <= mmx::view_as<slist<stl_inst_1> > (h[2]));
  stl_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_78 (mmx::generic g) {
  mmx::generic h = g[0];
  stl_type save_1 = stl_cur_1;
  stl_cur_1 = mmx::view_as<stl_type> (mmx::as_glue_type (g[1]));
  mmx::generic ret = mmx::single (mmx::view_as<slist<stl_inst_1> > (h[1]) > mmx::view_as<slist<stl_inst_1> > (h[2]));
  stl_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_79 (mmx::generic g) {
  mmx::generic h = g[0];
  stl_type save_1 = stl_cur_1;
  stl_cur_1 = mmx::view_as<stl_type> (mmx::as_glue_type (g[1]));
  mmx::generic ret = mmx::single (mmx::view_as<slist<stl_inst_1> > (h[1]) >= mmx::view_as<slist<stl_inst_1> > (h[2]));
  stl_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_80 (mmx::generic g) {
  mmx::generic h = g[0];
  stl_type save_1 = stl_cur_1;
  stl_cur_1 = mmx::view_as<stl_type> (mmx::as_glue_type (g[1]));
  mmx::generic ret = mmx::glued<stl_inst_1> (mmx::view_as<valarray<stl_inst_1> > (h[1])[mmx::as_int (h[2])]);
  stl_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_81 (mmx::generic g) {
  mmx::generic h = g[0];
  stl_type save_1 = stl_cur_1;
  stl_cur_1 = mmx::view_as<stl_type> (mmx::as_glue_type (g[1]));
  mmx::generic ret = mmx::glued_alias<stl_inst_1> (mmx::view_as_alias<valarray<stl_inst_1> > (h[1])[mmx::as_int (h[2])]);
  stl_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_82 (mmx::generic g) {
  mmx::generic h = g[0];
  stl_type save_1 = stl_cur_1;
  stl_cur_1 = mmx::view_as<stl_type> (mmx::as_glue_type (g[1]));
  mmx::generic ret = mmx::glued<valarray<stl_inst_1> > (-mmx::view_as<valarray<stl_inst_1> > (h[1]));
  stl_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_83 (mmx::generic g) {
  mmx::generic h = g[0];
  stl_type save_1 = stl_cur_1;
  stl_cur_1 = mmx::view_as<stl_type> (mmx::as_glue_type (g[1]));
  mmx::generic ret = mmx::glued<valarray<stl_inst_1> > (mmx::view_as<valarray<stl_inst_1> > (h[1]) + mmx::view_as<valarray<stl_inst_1> > (h[2]));
  stl_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_84 (mmx::generic g) {
  mmx::generic h = g[0];
  stl_type save_1 = stl_cur_1;
  stl_cur_1 = mmx::view_as<stl_type> (mmx::as_glue_type (g[1]));
  mmx::generic ret = mmx::glued<valarray<stl_inst_1> > (mmx::view_as<valarray<stl_inst_1> > (h[1]) - mmx::view_as<valarray<stl_inst_1> > (h[2]));
  stl_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_85 (mmx::generic g) {
  mmx::generic h = g[0];
  stl_type save_1 = stl_cur_1;
  stl_cur_1 = mmx::view_as<stl_type> (mmx::as_glue_type (g[1]));
  mmx::generic ret = mmx::glued<valarray<stl_inst_1> > (mmx::view_as<valarray<stl_inst_1> > (h[1]) * mmx::view_as<valarray<stl_inst_1> > (h[2]));
  stl_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_86 (mmx::generic g) {
  mmx::generic h = g[0];
  stl_type save_1 = stl_cur_1;
  stl_cur_1 = mmx::view_as<stl_type> (mmx::as_glue_type (g[1]));
  mmx::generic ret = mmx::glued<valarray<stl_inst_1> > (mmx::view_as<valarray<stl_inst_1> > (h[1]) / mmx::view_as<valarray<stl_inst_1> > (h[2]));
  stl_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_87 (mmx::generic g) {
  mmx::generic h = g[0];
  stl_type save_1 = stl_cur_1;
  stl_cur_1 = mmx::view_as<stl_type> (mmx::as_glue_type (g[1]));
  mmx::generic ret = mmx::glued_alias<valarray<stl_inst_1> > (mmx::view_as_alias<valarray<stl_inst_1> > (h[1]) += mmx::view_as<valarray<stl_inst_1> > (h[2]));
  stl_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_88 (mmx::generic g) {
  mmx::generic h = g[0];
  stl_type save_1 = stl_cur_1;
  stl_cur_1 = mmx::view_as<stl_type> (mmx::as_glue_type (g[1]));
  mmx::generic ret = mmx::glued_alias<valarray<stl_inst_1> > (mmx::view_as_alias<valarray<stl_inst_1> > (h[1]) -= mmx::view_as<valarray<stl_inst_1> > (h[2]));
  stl_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_89 (mmx::generic g) {
  mmx::generic h = g[0];
  stl_type save_1 = stl_cur_1;
  stl_cur_1 = mmx::view_as<stl_type> (mmx::as_glue_type (g[1]));
  mmx::generic ret = mmx::glued_alias<valarray<stl_inst_1> > (mmx::view_as_alias<valarray<stl_inst_1> > (h[1]) *= mmx::view_as<valarray<stl_inst_1> > (h[2]));
  stl_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_90 (mmx::generic g) {
  mmx::generic h = g[0];
  stl_type save_1 = stl_cur_1;
  stl_cur_1 = mmx::view_as<stl_type> (mmx::as_glue_type (g[1]));
  mmx::generic ret = mmx::glued_alias<valarray<stl_inst_1> > (mmx::view_as_alias<valarray<stl_inst_1> > (h[1]) /= mmx::view_as<valarray<stl_inst_1> > (h[2]));
  stl_cur_1 = save_1;
  return ret;
}

mmx::generic TMPL_1 = mmx::mirror (mmx::symbol (TMPL_1));

extern "C" void
init_stl () {
  mmx::extern_declare ("Int", ID_1, mmx::ID_CLASS);
  mmx::extern_declare ("Double", ID_2, mmx::ID_CLASS);
  mmx::extern_declare ("Complex", FUN_3, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::ID_CLASS), mmx::ID_CLASS));
  mmx::extern_declare ("Vector", FUN_4, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::ID_CLASS), mmx::ID_CLASS));
  mmx::extern_declare ("SList", FUN_5, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::ID_CLASS), mmx::ID_CLASS));
  mmx::extern_declare ("Valarray", FUN_6, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::ID_CLASS), mmx::ID_CLASS));
  mmx::extern_declare ("-", FUN_7, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, ID_2), ID_2));
  mmx::extern_declare ("+", FUN_8, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, ID_2, ID_2), ID_2));
  mmx::extern_declare ("-", FUN_9, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, ID_2, ID_2), ID_2));
  mmx::extern_declare ("*", FUN_10, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, ID_2, ID_2), ID_2));
  mmx::extern_declare ("/", FUN_11, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, ID_2, ID_2), ID_2));
  mmx::extern_declare ("^", FUN_12, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, ID_2, mmx::ID_INT), ID_2));
  mmx::extern_declare ("^", FUN_13, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, ID_2, ID_2), ID_2));
  mmx::extern_declare ("+=", FUN_14, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (mmx::ID_ALIAS, ID_2), ID_2), mmx::list (mmx::ID_ALIAS, ID_2)));
  mmx::extern_declare ("-=", FUN_15, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (mmx::ID_ALIAS, ID_2), ID_2), mmx::list (mmx::ID_ALIAS, ID_2)));
  mmx::extern_declare ("*=", FUN_16, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (mmx::ID_ALIAS, ID_2), ID_2), mmx::list (mmx::ID_ALIAS, ID_2)));
  mmx::extern_declare ("/=", FUN_17, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (mmx::ID_ALIAS, ID_2), ID_2), mmx::list (mmx::ID_ALIAS, ID_2)));
  mmx::extern_declare ("=", FUN_18, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, ID_2, ID_2), mmx::ID_BOOL));
  mmx::extern_declare ("!=", FUN_19, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, ID_2, ID_2), mmx::ID_BOOL));
  mmx::extern_declare ("<", FUN_20, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, ID_2, ID_2), mmx::ID_BOOL));
  mmx::extern_declare ("<=", FUN_21, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, ID_2, ID_2), mmx::ID_BOOL));
  mmx::extern_declare (">", FUN_22, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, ID_2, ID_2), mmx::ID_BOOL));
  mmx::extern_declare (">=", FUN_23, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, ID_2, ID_2), mmx::ID_BOOL));
  mmx::extern_declare ("abs", FUN_24, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, ID_2), ID_2));
  mmx::extern_declare ("sqrt", FUN_25, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, ID_2), ID_2));
  mmx::extern_declare ("exp", FUN_26, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, ID_2), ID_2));
  mmx::extern_declare ("ln", FUN_27, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, ID_2), ID_2));
  mmx::extern_declare ("sin", FUN_28, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, ID_2), ID_2));
  mmx::extern_declare ("cos", FUN_29, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, ID_2), ID_2));
  mmx::extern_declare ("tan", FUN_30, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, ID_2), ID_2));
  mmx::extern_declare ("sh", FUN_31, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, ID_2), ID_2));
  mmx::extern_declare ("ch", FUN_32, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, ID_2), ID_2));
  mmx::extern_declare ("th", FUN_33, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, ID_2), ID_2));
  mmx::extern_declare ("arcsin", FUN_34, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, ID_2), ID_2));
  mmx::extern_declare ("arccos", FUN_35, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, ID_2), ID_2));
  mmx::extern_declare ("arctan", FUN_36, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, ID_2), ID_2));
  mmx::extern_declare ("floor", FUN_37, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, ID_2), ID_2));
  mmx::extern_declare ("ceil", FUN_38, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, ID_2), ID_2));
  mmx::extern_declare ("arctan", FUN_39, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, ID_2, ID_2), ID_2));
  mmx::extern_declare ("hypot", FUN_40, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, ID_2, ID_2), ID_2));
  mmx::extern_declare ("-", FUN_41, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (ID_3, TMPL_1)), mmx::list (ID_3, TMPL_1))));
  mmx::extern_declare ("+", FUN_42, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (ID_3, TMPL_1), mmx::list (ID_3, TMPL_1)), mmx::list (ID_3, TMPL_1))));
  mmx::extern_declare ("-", FUN_43, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (ID_3, TMPL_1), mmx::list (ID_3, TMPL_1)), mmx::list (ID_3, TMPL_1))));
  mmx::extern_declare ("*", FUN_44, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (ID_3, TMPL_1), mmx::list (ID_3, TMPL_1)), mmx::list (ID_3, TMPL_1))));
  mmx::extern_declare ("/", FUN_45, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (ID_3, TMPL_1), mmx::list (ID_3, TMPL_1)), mmx::list (ID_3, TMPL_1))));
  mmx::extern_declare ("^", FUN_46, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (ID_3, TMPL_1), mmx::ID_INT), mmx::list (ID_3, TMPL_1))));
  mmx::extern_declare ("^", FUN_47, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (ID_3, TMPL_1), TMPL_1), mmx::list (ID_3, TMPL_1))));
  mmx::extern_declare ("^", FUN_48, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (ID_3, TMPL_1), mmx::list (ID_3, TMPL_1)), mmx::list (ID_3, TMPL_1))));
  mmx::extern_declare ("+=", FUN_49, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (mmx::ID_ALIAS, mmx::list (ID_3, TMPL_1)), mmx::list (ID_3, TMPL_1)), mmx::list (mmx::ID_ALIAS, mmx::list (ID_3, TMPL_1)))));
  mmx::extern_declare ("-=", FUN_50, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (mmx::ID_ALIAS, mmx::list (ID_3, TMPL_1)), mmx::list (ID_3, TMPL_1)), mmx::list (mmx::ID_ALIAS, mmx::list (ID_3, TMPL_1)))));
  mmx::extern_declare ("*=", FUN_51, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (mmx::ID_ALIAS, mmx::list (ID_3, TMPL_1)), mmx::list (ID_3, TMPL_1)), mmx::list (mmx::ID_ALIAS, mmx::list (ID_3, TMPL_1)))));
  mmx::extern_declare ("/=", FUN_52, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (mmx::ID_ALIAS, mmx::list (ID_3, TMPL_1)), mmx::list (ID_3, TMPL_1)), mmx::list (mmx::ID_ALIAS, mmx::list (ID_3, TMPL_1)))));
  mmx::extern_declare ("=", FUN_53, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (ID_3, TMPL_1), mmx::list (ID_3, TMPL_1)), mmx::ID_BOOL)));
  mmx::extern_declare ("!=", FUN_54, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (ID_3, TMPL_1), mmx::list (ID_3, TMPL_1)), mmx::ID_BOOL)));
  mmx::extern_declare ("polar", FUN_55, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, TMPL_1, TMPL_1), mmx::list (ID_3, TMPL_1))));
  mmx::extern_declare ("abs", FUN_56, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (ID_3, TMPL_1)), mmx::list (ID_3, TMPL_1))));
  mmx::extern_declare ("arg", FUN_57, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (ID_3, TMPL_1)), mmx::list (ID_3, TMPL_1))));
  mmx::extern_declare ("conj", FUN_58, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (ID_3, TMPL_1)), mmx::list (ID_3, TMPL_1))));
  mmx::extern_declare ("sqrt", FUN_59, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (ID_3, TMPL_1)), mmx::list (ID_3, TMPL_1))));
  mmx::extern_declare ("exp", FUN_60, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (ID_3, TMPL_1)), mmx::list (ID_3, TMPL_1))));
  mmx::extern_declare ("ln", FUN_61, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (ID_3, TMPL_1)), mmx::list (ID_3, TMPL_1))));
  mmx::extern_declare ("sin", FUN_62, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (ID_3, TMPL_1)), mmx::list (ID_3, TMPL_1))));
  mmx::extern_declare ("cos", FUN_63, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (ID_3, TMPL_1)), mmx::list (ID_3, TMPL_1))));
  mmx::extern_declare ("sh", FUN_64, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (ID_3, TMPL_1)), mmx::list (ID_3, TMPL_1))));
  mmx::extern_declare ("ch", FUN_65, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (ID_3, TMPL_1)), mmx::list (ID_3, TMPL_1))));
  mmx::extern_declare (".[]", FUN_66, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (ID_4, TMPL_1), mmx::ID_INT), TMPL_1)));
  mmx::extern_declare (".[]", FUN_67, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (mmx::ID_ALIAS, mmx::list (ID_4, TMPL_1)), mmx::ID_INT), mmx::list (mmx::ID_ALIAS, TMPL_1))));
  mmx::extern_declare ("=", FUN_68, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (ID_4, TMPL_1), mmx::list (ID_4, TMPL_1)), mmx::ID_BOOL)));
  mmx::extern_declare ("!=", FUN_69, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (ID_4, TMPL_1), mmx::list (ID_4, TMPL_1)), mmx::ID_BOOL)));
  mmx::extern_declare ("<", FUN_70, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (ID_4, TMPL_1), mmx::list (ID_4, TMPL_1)), mmx::ID_BOOL)));
  mmx::extern_declare ("<=", FUN_71, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (ID_4, TMPL_1), mmx::list (ID_4, TMPL_1)), mmx::ID_BOOL)));
  mmx::extern_declare (">", FUN_72, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (ID_4, TMPL_1), mmx::list (ID_4, TMPL_1)), mmx::ID_BOOL)));
  mmx::extern_declare (">=", FUN_73, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (ID_4, TMPL_1), mmx::list (ID_4, TMPL_1)), mmx::ID_BOOL)));
  mmx::extern_declare ("=", FUN_74, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (ID_5, TMPL_1), mmx::list (ID_5, TMPL_1)), mmx::ID_BOOL)));
  mmx::extern_declare ("!=", FUN_75, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (ID_5, TMPL_1), mmx::list (ID_5, TMPL_1)), mmx::ID_BOOL)));
  mmx::extern_declare ("<", FUN_76, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (ID_5, TMPL_1), mmx::list (ID_5, TMPL_1)), mmx::ID_BOOL)));
  mmx::extern_declare ("<=", FUN_77, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (ID_5, TMPL_1), mmx::list (ID_5, TMPL_1)), mmx::ID_BOOL)));
  mmx::extern_declare (">", FUN_78, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (ID_5, TMPL_1), mmx::list (ID_5, TMPL_1)), mmx::ID_BOOL)));
  mmx::extern_declare (">=", FUN_79, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (ID_5, TMPL_1), mmx::list (ID_5, TMPL_1)), mmx::ID_BOOL)));
  mmx::extern_declare (".[]", FUN_80, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (ID_6, TMPL_1), mmx::ID_INT), TMPL_1)));
  mmx::extern_declare (".[]", FUN_81, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (mmx::ID_ALIAS, mmx::list (ID_6, TMPL_1)), mmx::ID_INT), mmx::list (mmx::ID_ALIAS, TMPL_1))));
  mmx::extern_declare ("-", FUN_82, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (ID_6, TMPL_1)), mmx::list (ID_6, TMPL_1))));
  mmx::extern_declare ("+", FUN_83, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (ID_6, TMPL_1), mmx::list (ID_6, TMPL_1)), mmx::list (ID_6, TMPL_1))));
  mmx::extern_declare ("-", FUN_84, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (ID_6, TMPL_1), mmx::list (ID_6, TMPL_1)), mmx::list (ID_6, TMPL_1))));
  mmx::extern_declare ("*", FUN_85, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (ID_6, TMPL_1), mmx::list (ID_6, TMPL_1)), mmx::list (ID_6, TMPL_1))));
  mmx::extern_declare ("/", FUN_86, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (ID_6, TMPL_1), mmx::list (ID_6, TMPL_1)), mmx::list (ID_6, TMPL_1))));
  mmx::extern_declare ("+=", FUN_87, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (mmx::ID_ALIAS, mmx::list (ID_6, TMPL_1)), mmx::list (ID_6, TMPL_1)), mmx::list (mmx::ID_ALIAS, mmx::list (ID_6, TMPL_1)))));
  mmx::extern_declare ("-=", FUN_88, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (mmx::ID_ALIAS, mmx::list (ID_6, TMPL_1)), mmx::list (ID_6, TMPL_1)), mmx::list (mmx::ID_ALIAS, mmx::list (ID_6, TMPL_1)))));
  mmx::extern_declare ("*=", FUN_89, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (mmx::ID_ALIAS, mmx::list (ID_6, TMPL_1)), mmx::list (ID_6, TMPL_1)), mmx::list (mmx::ID_ALIAS, mmx::list (ID_6, TMPL_1)))));
  mmx::extern_declare ("/=", FUN_90, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (mmx::ID_ALIAS, mmx::list (ID_6, TMPL_1)), mmx::list (ID_6, TMPL_1)), mmx::list (mmx::ID_ALIAS, mmx::list (ID_6, TMPL_1)))));
}

