
/******************************************************************************
* MODULE     : conv_aliases.cc
* DESCRIPTION: Consider tuples of aliases as aliases during conversion
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <evaluator.hh>
#include <aliases.hh>
namespace mmx {

static list
remove_aliases (list l) {
  if (nil (l)) return l;
  if (!is_func (car (l), ID_ALIAS, 1))
    fatal_error ("alias type expected", "remove_aliases", "conv_aliases.cc");
  return cons (car (l) [1], remove_aliases (cdr (l)));
}

void
evaluator_rep::kw_conv_aliases_1 () {
  CHECK_SYNC (CONV_ALIASES);
  evaluate_args (KW_CONV_ALIASES_2);
}

void
evaluator_rep::kw_conv_aliases_2 () {
  CHECK_SYNC (CONV_ALIASES);
  // INPUT: (conv_aliases_2, args, cont, ...)
  list    l   = as_list (car (rem));
  generic arg = aliases (cons (MMX_TUPLE, get_values (l)));
  list    r   = remove_aliases (get_types (l));
  generic type= list (ID_ALIAS, cons (ID_CROSS, r));
  cur= cadr (rem);
  rem= cons (value (arg, type), cddr (rem));
  // OUTPUT: (cont, tuple, ...)
  trace= cdr (trace);
}

} // namespace mmx
