
/******************************************************************************
* MODULE     : lib_print_code.cc
* DESCRIPTION: Printing code
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <evaluator.hh>
#include <printer.hh>
#include <scheme.hh>
namespace mmx {

void
evaluator_rep::lib_print_code_1 () {
  CHECK_SYNC (MMX_PRINT_CODE);
  // Input: (print_code_1, arg, cont, ...)
  list    ret = cdr (as_list (car (rem)));
  printer out = as_printer (car (ret));
  generic code= cadr (ret);
  if (mmx_lib_name -> contains (code))
    out->out << mmx_lib_name [code];
  else raw_print (out->out, scheme_to_string (code));
  cur= value (out, ID_OSTREAM);
  rem= cdr (rem);
  // Output: (cont, out, ...)
  trace= cdr (trace);
}

} // namespace mmx
