
/******************************************************************************
* MODULE     : single.hh
* DESCRIPTION: mathemagix output streams
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#ifndef __SINGLE_HH
#define __SINGLE_HH
#include <list.hh>
namespace mmx {

class single;
class single_rep: generic_rep {
public:
  int i;  // the ostream

protected:
  int Type ();
  int Hash ();
  bool Equal (generic g);
  generic Copy ();
  int Arity ();
  void Print (ostream& out);

public:
  inline single_rep (int i2): i (i2) {}

  friend class single;
  friend single copy (single t);
  friend ostream& operator << (ostream& out, single a);
};

class single {
protected:
  single_rep* rep;
  inline single (single_rep* rep2): rep (rep2) {}

public:
  inline single (int i): rep (new single_rep (i)) {}
  inline single (bool b): rep (new single_rep ((int) b)) {}
  inline friend single as_single (generic g) {
    if (gentype(g) != SINGLE_TYPE) type_mismatch (g, "single");
    return single ((single_rep*) g.rep); }
  inline operator int () { return rep->i; }
  inline operator generic () { return generic (rep); }
  inline single_rep* operator -> () { return rep; }

  inline bool operator == (single out) {
    return (rep->i == out->i); }
  inline bool operator != (single out) {
    return (rep->i != out->i); }
  friend single copy (single i);
  friend ostream& operator << (ostream& out, single i);

  friend class single_rep;
};

inline int as_int (generic g) { return as_single (g)->i; }
inline bool as_bool (generic g) { return (bool) as_single (g)->i; }

}
#endif // __SINGLE_HH
